/* PointTest.java 1.0  26 January 2003 */

public class PointTest extends JPFalt 
{
    public static void main(String[] args) { new PointTest(); }
    
    ///////////////////////////////////////////////////////////
    // Place your actual methods here.                       //
    ///////////////////////////////////////////////////////////

	/** Test suite for the class hierarchy representing points */
	
	/*-------------------------------------------------------------------------
	 Define a ManhattanPoint object and print the member data values.
	-------------------------------------------------------------------------*/
    void TestManhattanPoint(){
    
    	println("\nDefine ManhattanPoint objects, print member data values");
    	println(new ManhattanPoint(20, 30));
    	println(new ManhattanPoint(15, 22));
    }
    
	/*-------------------------------------------------------------------------
	 Define a CartesianPoint object and print the member data values.
	-------------------------------------------------------------------------*/
    void TestCartesianPoint(){
    
    	println("\nDefine CartesianPoint objects, print member data values");
    	println(new CartesianPoint(20, 30));
    	println(new CartesianPoint(15, 22));
    }
    
	/*-------------------------------------------------------------------------
	 Define a Cartesian3dPoint object and print the member data values.
	-------------------------------------------------------------------------*/
    void TestCartesian3dPoint(){
    
    	println("\nDefine Cartesian3dPoint objects, print member data values");
    	println(new Cartesian3dPoint(20, 30, 10));
    	println(new Cartesian3dPoint(12, 17, 29));
    }
    
	/*------------------------------------------------------------------------- 
	 Test the distanceToOrigin() method in the class ManhattanPoint
	-------------------------------------------------------------------------*/
    void TestDistanceToOrigin_MP(){

    	testHeader("distanceToOrigin() in ManahttanPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two ManhattanPoint objects. 
    	---------------------------------------------------------------------*/
    	ManhattanPoint mp1 = new ManhattanPoint(20, 30);
    	ManhattanPoint mp2 = new ManhattanPoint(15, 22);
    	    	
    	expected(50);
    	actual( mp1.distanceToOrigin() );
    	
    	expected(37);
    	actual( mp2.distanceToOrigin() );
    }

	/*------------------------------------------------------------------------- 
	 Test the distanceToOrigin() method in the class CartesianPoint
	-------------------------------------------------------------------------*/
    void TestDistanceToOrigin_CP(){

    	testHeader("distanceToOrigin() in CartesianPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two CartesianPoint objects. 
    	---------------------------------------------------------------------*/
    	CartesianPoint cp1 = new CartesianPoint(3, 4);
    	CartesianPoint cp2 = new CartesianPoint(6, 8);
    	    	
    	expected(5);
    	actual( cp1.distanceToOrigin() );
    	
    	expected(10);
    	actual( cp2.distanceToOrigin() );
    }

	/*------------------------------------------------------------------------- 
	 Test the distanceToOrigin() method in the class Cartesian3dPoint
	-------------------------------------------------------------------------*/
    void TestDistanceToOrigin_C3dP(){

    	testHeader("distanceToOrigin() in Cartesian3dPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two Cartesian3dPoint objects. 
    	---------------------------------------------------------------------*/
    	Cartesian3dPoint c3p1 = new Cartesian3dPoint(5, 6, 7);
    	Cartesian3dPoint c3p2 = new Cartesian3dPoint(6, 7, 8);
    	    	
    	expected(10.489);
    	actual( c3p1.distanceToOrigin() );
    	
    	expected(12.2065);
    	actual( c3p2.distanceToOrigin() );
    }
    
    
	/*------------------------------------------------------------------------- 
	 Test the isWithin(someDistance) method in the class ManhattanPoint
	-------------------------------------------------------------------------*/
    void TestIsWithin_MP(){

    	testHeader("isWithin(someDistance) in ManhattanPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two ManhattanPoint objects. 
    	---------------------------------------------------------------------*/
    	ManhattanPoint mp1 = new ManhattanPoint(20, 30);
    	ManhattanPoint mp2 = new ManhattanPoint(15, 22);
    	    	    	    	
    	expected(false);
    	actual( mp1.isWithin(40) );
    	
    	expected(true);
    	actual( mp2.isWithin(40) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the isWithin(someDistance) method in the class CartesianPoint
	-------------------------------------------------------------------------*/
    void TestIsWithin_CP(){

    	testHeader("isWithin(someDistance) in CartesianPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two CartesianPoint objects. 
    	---------------------------------------------------------------------*/
    	CartesianPoint cp1 = new CartesianPoint(3, 4);
    	CartesianPoint cp2 = new CartesianPoint(6, 8);
    	    	
    	expected(true);
    	actual( cp1.isWithin(10) );
    	
    	expected(false);
    	actual( cp2.isWithin(10) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the isWithin(someDistance) method in the class Cartesian3dPoint
	-------------------------------------------------------------------------*/
    void TestIsWithin_C3dP(){

    	testHeader("isWithin(someDistance) in Cartesian3dPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two Cartesian3dPoint objects. 
    	---------------------------------------------------------------------*/
    	Cartesian3dPoint c3p1 = new Cartesian3dPoint(5, 6, 7);
    	Cartesian3dPoint c3p2 = new Cartesian3dPoint(6, 7, 8);
    	    	
    	expected(true);
    	actual( c3p1.isWithin(12) );
    	
    	expected(false);
    	actual( c3p2.isWithin(12) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the isCloserThan(somePoint) method in the class ManhattanPoint
	-------------------------------------------------------------------------*/
    void TestIsCloserThan_MP(){

    	testHeader("isCloserThan(somePoint) in ManhattanPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two ManhattanPoint objects. 
    	---------------------------------------------------------------------*/
    	ManhattanPoint mp1 = new ManhattanPoint(20, 30);
    	ManhattanPoint mp2 = new ManhattanPoint(15, 22);
    	    	    	    	
    	expected(false);
    	actual( mp1.isCloserThan(mp2) );
    	
    	expected(true);
    	actual( mp2.isCloserThan(mp1) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the isCloserThan(somePoint) method in the class CartesianPoint
	-------------------------------------------------------------------------*/
    void TestIsCloserThan_CP(){

    	testHeader("isCloserThan(somePoint) in CartesianPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two CartesianPoint objects. 
    	---------------------------------------------------------------------*/
    	CartesianPoint cp1 = new CartesianPoint(3, 4);
    	CartesianPoint cp2 = new CartesianPoint(6, 8);
    	    	
    	expected(true);
    	actual( cp1.isCloserThan(cp2) );
    	
    	expected(false);
    	actual( cp2.isCloserThan(cp1) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the isCloserThan(somePoint) method in the class Cartesian3dPoint
	-------------------------------------------------------------------------*/
    void TestIsCloserThan_C3dP(){

    	testHeader("isCloserThan(somePoint) in Cartesian3dPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two Cartesian3dPoint objects. 
    	---------------------------------------------------------------------*/
    	Cartesian3dPoint c3p1 = new Cartesian3dPoint(5, 6, 7);
    	Cartesian3dPoint c3p2 = new Cartesian3dPoint(6, 7, 8);
    	    	
    	expected(true);
    	actual( c3p1.isCloserThan(c3p2) );
    	
    	expected(false);
    	actual( c3p2.isCloserThan(c3p1) );
    }
    

	/*------------------------------------------------------------------------- 
	 Test the isCloserThan(somePoint) method in the class hierarchy
	-------------------------------------------------------------------------*/
    void TestIsCloserThan(){

    	testHeader("isCloserThan(somePoint) in the point class hierarchy");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two ManhattanPoint objects. 
    	---------------------------------------------------------------------*/
    	ManhattanPoint mp1 = new ManhattanPoint(20, 30);
    	ManhattanPoint mp2 = new ManhattanPoint(15, 22);
    	    	    	    	
    	/*--------------------------------------------------------------------- 
    	 Define two CartesianPoint objects. 
    	---------------------------------------------------------------------*/
    	CartesianPoint cp1 = new CartesianPoint(3, 4);
    	CartesianPoint cp2 = new CartesianPoint(6, 8);
    	    	
    	/*--------------------------------------------------------------------- 
    	 Define two Cartesian3dPoint objects. 
    	---------------------------------------------------------------------*/
    	Cartesian3dPoint c3p1 = new Cartesian3dPoint(5, 6, 7);
    	Cartesian3dPoint c3p2 = new Cartesian3dPoint(6, 7, 8);
    	    	

    	expected(true);
    	actual( cp1.isCloserThan(mp1) );
    	
    	expected(true);
    	actual( cp2.isCloserThan(c3p1) );

    	expected(false);
    	actual( mp1.isCloserThan(cp2) );
    	
    	expected(false);
    	actual( mp2.isCloserThan(c3p2) );

    	expected(true);
    	actual( c3p2.isCloserThan(mp1) );
    	
    	expected(false);
    	actual( c3p2.isCloserThan(cp2) );
    }
    
    
	/*------------------------------------------------------------------------- 
	 Test the getCloserPoint(somePoint) method in the class ManhattanPoint
	-------------------------------------------------------------------------*/
    void TestGetCloserPoint_MP(){

    	testHeader("getCloserPoint(somePoint) in ManhattanPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two ManhattanPoint objects. 
    	---------------------------------------------------------------------*/
    	ManhattanPoint mp1 = new ManhattanPoint(20, 30);
    	ManhattanPoint mp2 = new ManhattanPoint(15, 22);
    	    	    	    	
    	expected(mp2);
    	actual( mp1.getCloserPoint(mp2) );
    	
    	expected(mp2);
    	actual( mp2.getCloserPoint(mp1) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the getCloserPoint(somePoint) method in the class CartesianPoint
	-------------------------------------------------------------------------*/
    void TestGetCloserPoint_CP(){

    	testHeader("getCloserPoint(somePoint) in CartesianPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two CartesianPoint objects. 
    	---------------------------------------------------------------------*/
    	CartesianPoint cp1 = new CartesianPoint(3, 4);
    	CartesianPoint cp2 = new CartesianPoint(6, 8);
    	    	
    	expected(cp1);
    	actual( cp1.getCloserPoint(cp2) );
    	
    	expected(cp1);
    	actual( cp2.getCloserPoint(cp1) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the getCloserPoint(somePoint) method in the class Cartesian3dPoint
	-------------------------------------------------------------------------*/
    void TestGetCloserPoint_C3dP(){

    	testHeader("getCloserPoint(somePoint) in Cartesian3dPoint class");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two Cartesian3dPoint objects. 
    	---------------------------------------------------------------------*/
    	Cartesian3dPoint c3p1 = new Cartesian3dPoint(5, 6, 7);
    	Cartesian3dPoint c3p2 = new Cartesian3dPoint(6, 7, 8);
    	    	
    	expected(c3p1);
    	actual( c3p1.getCloserPoint(c3p2) );
    	
    	expected(c3p1);
    	actual( c3p2.getCloserPoint(c3p1) );
    }
    
	/*------------------------------------------------------------------------- 
	 Test the getCloserPoint(somePoint) method in the class hierarchy
	-------------------------------------------------------------------------*/
    void TestGetCloserPoint(){

    	testHeader("getCloserPoint(somePoint) in the point class hierarchy");
    	
    	/*--------------------------------------------------------------------- 
    	 Define two ManhattanPoint objects. 
    	---------------------------------------------------------------------*/
    	ManhattanPoint mp1 = new ManhattanPoint(20, 30);
    	ManhattanPoint mp2 = new ManhattanPoint(15, 22);
    	    	    	    	
    	/*--------------------------------------------------------------------- 
    	 Define two CartesianPoint objects. 
    	---------------------------------------------------------------------*/
    	CartesianPoint cp1 = new CartesianPoint(3, 4);
    	CartesianPoint cp2 = new CartesianPoint(6, 8);
    	    	
    	/*--------------------------------------------------------------------- 
    	 Define two Cartesian3dPoint objects. 
    	---------------------------------------------------------------------*/
    	Cartesian3dPoint c3p1 = new Cartesian3dPoint(5, 6, 7);
    	Cartesian3dPoint c3p2 = new Cartesian3dPoint(6, 7, 8);
    	    	

    	expected(cp1);
    	actual( cp1.getCloserPoint(mp1) );
    	
    	expected(cp2);
    	actual( cp2.getCloserPoint(c3p1) );

    	expected(cp2);
    	actual( mp1.getCloserPoint(cp2) );
    	
    	expected(c3p2);
    	actual( mp2.getCloserPoint(c3p2) );

    	expected(c3p2);
    	actual( c3p2.getCloserPoint(mp1) );
    	
    	expected(cp2);
    	actual( c3p2.getCloserPoint(cp2) );
    }
    

/*-----------------------------------------------------------------------------   	
 End of test suite for the class hierarchy representing points
 ----------------------------------------------------------------------------*/    
   
}
